VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Prosta"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'***************************************************************************
'*
'* NAZWA MODULU:    EXCEL 2007 PROGRAMMERS REFERENCE AUTOMATION ADDIN
'* AUTOR:           STEPHEN BULLEN, Business Modelling Solutions Ltd.
'*
'* KONTAKT:         Stephen@OALtd.co.uk
'* WWW:             http://www.OALtd.co.uk
'*
'* OPIS:            Dodatek automatyzacji dla Excel 2007
'*
'* TEN MODUL:       Przyklad prostego dodatku automatyzacji
'*
'* PROCEDURY:
'*  Sekwencja       Funkcja zwracajca sekwencje liczb
'*
'***************************************************************************

Option Explicit


'***************************************************************************
'*
'* NAZWA FUNKCJI:   Sekwencja
'*
'* OPIS:            Zwraca sekwencje liczb czesto uzywana w formulach tabel.
'*
'* PARAMETRY:       Elementy    Liczba elementow sekwencji
'*                  Start       Poczatkowa wartosc sekwencji, domyslnie = 1
'*                  Krok        Wartosc kroku w sekwencji, domyslnie = 1
'*
'***************************************************************************

Public Function Sekwencja(Elementy As Long, Optional Start As Double = 1, _
                         Optional Krok As Double = 1) As Variant

    Dim vaWynik As Variant
    Dim i As Long
    Dim dWartosc As Double

    'Sprawdzanie wpisow
    If Elementy < 1 Then
        Sekwencja = CVErr(2015)        '#Value
        Exit Function
    End If

    'Tworzenie tablicy dla serii
    ReDim vaWynik(1 To Elementy)

    'Pobieranie wartosci poczatkowej
    dWartosc = Start

    'Obliczanie wszystkich wartosci, wypelnianie tabeli
    For i = 1 To Elementy
        vaWynik(i) = dWartosc
        dWartosc = dWartosc + Krok
    Next

    'Zwrocenie tablicy
    Sekwencja = vaWynik

End Function


